﻿Imports Microsoft.Kinect
Class MainWindow
    Private myKinect As KinectSensor
    Private myColorFrameReader As ColorFrameReader = Nothing
    Private colorBitmap As WriteableBitmap = Nothing
    Private ColorImagePixelData As Byte()
    Private BytesPerPixel As Integer = 4 'CInt(PixelFormats.Bgr32.BitsPerPixel / 8)

  
    Private Sub MainWindow_Loaded(sender As Object, e As RoutedEventArgs) Handles Me.Loaded
        myKinect = KinectSensor.GetDefault
        If myKinect Is Nothing = False Then
            myColorFrameReader = myKinect.ColorFrameSource.OpenReader
            Dim myColorFrameDescripton As FrameDescription = myKinect.ColorFrameSource.CreateFrameDescription(ColorImageFormat.Bgra)
            ColorImagePixelData = New Byte(myColorFrameDescripton.Width * myColorFrameDescripton.Height * BytesPerPixel - 1) {}
            colorBitmap = New WriteableBitmap(myColorFrameDescripton.Width, myColorFrameDescripton.Height, 96.0, 96.0, PixelFormats.Bgr32, Nothing)
            AddHandler myColorFrameReader.FrameArrived, AddressOf myColorFrameReader_FrameArrived
            myKinect.Open()
        End If
    End Sub

    Private Sub myColorFrameReader_FrameArrived(sender As Object, e As ColorFrameArrivedEventArgs)

        Using myColorFrame As ColorFrame = e.FrameReference.AcquireFrame
            If myColorFrame Is Nothing = True Then
                Return
            End If
            myColorFrame.CopyConvertedFrameDataToArray(ColorImagePixelData, ColorImageFormat.Bgra)
        End Using

        colorBitmap.WritePixels(New Int32Rect(0, 0, colorBitmap.PixelWidth, colorBitmap.PixelHeight), ColorImagePixelData, colorBitmap.PixelWidth * BytesPerPixel, 0)
        Image1.Source = colorBitmap
    End Sub

    Private Sub MainWindow_Closing(sender As Object, e As ComponentModel.CancelEventArgs) Handles Me.Closing
        If myColorFrameReader Is Nothing = False Then
            myColorFrameReader.Dispose()
            myColorFrameReader = Nothing
        End If
        If myKinect Is Nothing = False Then
            myKinect.Close()
            myKinect = Nothing
        End If
    End Sub

End Class
